package org.amse.shElena.toyRec.samples;

/**
 * An interface for a sample - form of a pair symbol and its picture.
 */
public interface ISample {
	/**
	 * Symbol the sample contains.
	 * 
	 * @return symbol.
	 */
	Character getSymbol();

	/**
	 * Image of the symbol.
	 * 
	 * @return boolean[][] which is representation of the picture of the symbol.
	 */
	boolean[][] getImage();

	/**
	 * Representation of the image to write to file.
	 * 
	 * @return string representation of the image.
	 */
	String writeImageToString();

	/**
	 * Reads an image from the given string. Should fit writeImageToString()
	 * method.
	 * 
	 * @param string string to read.
	 * @param width limitation of the first index if returned image.
	 * @param height limitation of the second index if returned image.
	 * @return image.
	 */
	boolean[][] readImage(String string, int width, int height);
}
